https://stackoverflow.com/questions/714100/os-detecting-makefile
https://unix.stackexchange.com/questions/6345/how-can-i-get-distribution-name-and-version-number-in-a-simple-shell-script


MAC:
cat /System/Library/CoreServices/SystemVersion.plist

<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
                <key>ProductBuildVersion</key>
                <string>16F73</string>
                <key>ProductCopyright</key>
                <string>1983-2017 Apple Inc.</string>
                <key>ProductName</key>
                <string>Mac OS X</string>
                <key>ProductUserVisibleVersion</key>
                <string>10.12.5</string>
                <key>ProductVersion</key>
                <string>10.12.5</string>
</dict>
</plist>
# cat /etc/lsb-release
#LSB_VERSION=1.4
#DISTRIB_ID=Arch
#DISTRIB_RELEASE=rolling
#DISTRIB_DESCRIPTION="Arch Linux"


#FILE_LSB_RELEASE='/etc/lsb-release'

#echo SISTEMA: ${SISTEMA} ;

#$uname -a
#Linux challenger1-Lenovo-Y50-70 4.4.0-98-generic #121-Ubuntu SMP Tue Oct 10 14:24:03 UTC 2017 x86_64 x86_64 x86_64 GNU/Linux
#GNU/Linux

#DISTRO2=`echo $DISTROU  | grep arch`
#DISTRO3=`echo $DISTROU  | grep microsoft`


#Darwin Fernandos-MBP 16.7.0 Darwin Kernel Version 16.7.0: Thu Jun 15 17:36:27 PDT 2017; root:xnu-3789.70.16~2/RELEASE_X86_64 x86_64

#windows10ubuntu
#Linux LAPTOP-10KRO9TT 4.4.0-43-Microsoft #1-Microsoft Wed Dec 31 14:42:53 PST 2014 x86_64 x86_64 x86_64 GNU/Linux

# GNU/Linux 
#Cygwin* MINGW* FreeBSD Solaris SunOS OpenBSD NetBSD Darwin
#Arch
#Microsoft

# "uname -a"
#Linux mork 4.8.10-1-ARCH #1 SMP PREEMPT Mon Nov 21 11:55:43 CET 2016 x86_64 GNU/Linux

#Sun JDS	/etc/sun-release
#Solaris/Sparc	/etc/release
#UnitedLinux	/etc/UnitedLinux-release

#gcc --version

#OS=`uname -s`
#REV=`uname -r`
#MACH=`uname -m`

GetVersionFromFile()
{
	VERSION=`cat $1 | tr "\n" ' ' | sed s/.*VERSION.*=\ // `
}

if [ "${OS}" = "SunOS" ] ; then
	OS=Solaris
	ARCH=`uname -p`	
	OSSTR="${OS} ${REV}(${ARCH} `uname -v`)"
elif [ "${OS}" = "AIX" ] ; then
	OSSTR="${OS} `oslevel` (`oslevel -r`)"
elif [ "${OS}" = "Linux" ] ; then
	KERNEL=`uname -r`
	if [ -f /etc/redhat-release ] ; then
		DIST='RedHat'
		PSUEDONAME=`cat /etc/redhat-release | sed s/.*\(// | sed s/\)//`
		REV=`cat /etc/redhat-release | sed s/.*release\ // | sed s/\ .*//`
	elif [ -f /etc/SUSE-release ] ; then
		DIST=`cat /etc/SUSE-release | tr "\n" ' '| sed s/VERSION.*//`
		REV=`cat /etc/SUSE-release | tr "\n" ' ' | sed s/.*=\ //`
	elif [ -f /etc/mandrake-release ] ; then
		DIST='Mandrake'
		PSUEDONAME=`cat /etc/mandrake-release | sed s/.*\(// | sed s/\)//`
		REV=`cat /etc/mandrake-release | sed s/.*release\ // | sed s/\ .*//`
	elif [ -f /etc/debian_version ] ; then
		DIST="Debian `cat /etc/debian_version`"
		REV=""

	fi
	
	OSSTR="${OS} ${DIST} ${REV}(${PSUEDONAME} ${KERNEL} ${MACH})"

fi


#INXI
#echo ${OSSTR}

## DISTRO DATA/ID ##
# In cases of derived distros where the version file of the base distro can also be found under /etc,
# the derived distro's version file should go first. (Such as with Sabayon / Gentoo)
DISTROS_DERIVED="antix-version aptosid-version kanotix-version knoppix-version mandrake-release mx-version pardus-release porteus-version sabayon-release siduction-version sidux-version slitaz-release solusos-release turbolinux-release zenwalk-version"
# debian_version excluded from DISTROS_PRIMARY so Debian can fall through to /etc/issue detection. Same goes for Ubuntu.
DISTROS_EXCLUDE_LIST="debian_version devuan_version ubuntu_version"
DISTROS_PRIMARY="arch-release gentoo-release redhat-release slackware-version SuSE-release"
DISTROS_LSB_GOOD="mandrake-release mandriva-release mandrakelinux-release"
# this is being used both by core distros and derived distros now, eg, solusos 1 uses it for solusos id, while
# debian, solusos base, uses it as well, so we have to know which it is.
DISTROS_OS_RELEASE_GOOD="arch-release SuSE-release "
## Distros with known problems
# DSL (Bash 2.05b: grep -m doesn't work; arrays won't work) --> unusable output
# Puppy Linux 4.1.2 (Bash 3.0: arrays won't work) --> works partially

#Supported repo types: APK; APT; PACMAN; PISI; PORTAGE; PORTS (BSDs); SLACKPKG; URPMQ; YUM; ZYPP.


get_distro_data()
{
	eval $LOGFS
	local i='' j='' distro='' distro_file='' a_distro_glob='' a_temp='' b_osr='false'
	
	# may need modification if archbsd / debian can be id'ed with /etc files
	if [[ -n $BSD_TYPE ]];then
		if [[ $BSD_VERSION != 'darwin' ]];then
			distro=$( uname -sr )
		else
			if [[ -f /System/Library/CoreServices/SystemVersion.plist ]];then
				distro=$( grep -A1 -E '(ProductName|ProductVersion)' /System/Library/CoreServices/SystemVersion.plist  | grep '<string>' | sed -E 's/<[\/]?string>//g' )
				distro=$( echo $distro )
			fi
			if [[ -z $distro ]];then
				distro='Mac OS X'
			fi
		fi
		echo "$distro"
		log_function_data "distro: $distro"
		eval $LOGFE
		return 0
	fi

	# get the wild carded array of release/version /etc files if present
	shopt -s nullglob
	cd /etc
	# note: always exceptions, so wild card after release/version: /etc/lsb-release-crunchbang
	# wait to handle since crunchbang file is one of the few in the world that uses this method
	a_distro_glob=(*[-_]{release,version})
	cd "$OLDPWD"
	shopt -u nullglob
	
	a_temp=${a_distro_glob[@]}
	log_function_data "a_distro_glob: $a_temp"

	if [[ ${#a_distro_glob[@]} -eq 1 ]];then
		distro_file="$a_distro_glob"
	# use the file if it's in the known good lists
	elif [[ ${#a_distro_glob[@]} -gt 1 ]];then
		for i in $DISTROS_DERIVED $DISTROS_PRIMARY
		do
			# Only echo works with ${var[@]}, not print_screen_output() or script_debugger()
			# This is a known bug, search for the word "strange" inside comments
			# echo "i='$i' a_distro_glob[@]='${a_distro_glob[@]}'"
			if [[ " ${a_distro_glob[@]} " == *" $i "* ]];then
				# Now lets see if the distro file is in the known-good working-lsb-list
				# if so, use lsb-release, if not, then just use the found file
				# this is for only those distro's with self named release/version files
				# because Mint does not use such, it must be done as below 
				## this if statement requires the spaces and * as it is, else it won't work
				##
				if [[ " $DISTROS_LSB_GOOD " == *" $i "* ]] && [[ $B_LSB_FILE == 'true' ]];then
					distro_file='lsb-release'
				elif [[ " $DISTROS_OS_RELEASE_GOOD " == *" $i "* ]] && [[ $B_OS_RELEASE_FILE == 'true' ]];then
					distro_file='os-release'
				else
					distro_file="$i"
				fi
				break
			fi
		done
	fi
	log_function_data "distro_file: $distro_file"
	# first test for the legacy antiX distro id file
	if [[ -e /etc/antiX ]];then
		distro="$( grep -Eoi 'antix.*\.iso' <<< $( remove_erroneous_chars '/etc/antiX' ) | sed 's/\.iso//' )"
	# this handles case where only one release/version file was found, and it's lsb-release. This would
	# never apply for ubuntu or debian, which will filter down to the following conditions. In general
	# if there's a specific distro release file available, that's to be preferred, but this is a good backup.
	elif [[ -n $distro_file && $B_LSB_FILE == 'true' && " $DISTROS_LSB_GOOD" == *" $distro_file "* ]];then
		distro=$( get_distro_lsb_os_release_data 'lsb-file' )
	elif [[ $distro_file == 'lsb-release' ]];then
		distro=$( get_distro_lsb_os_release_data 'lsb-file' )
	elif [[ $distro_file == 'os-release' ]];then
		distro=$( get_distro_lsb_os_release_data 'os-release-file' )
		b_osr='true'
	# then if the distro id file was found and it's not in the exluded primary distro file list, read it
	elif [[ -n $distro_file && -s /etc/$distro_file && " $DISTROS_EXCLUDE_LIST " != *" $distro_file "* ]];then
		# new opensuse uses os-release, but older ones may have a similar syntax, so just use the first line
		if [[ $distro_file == 'SuSE-release' ]];then
			# leaving off extra data since all new suse have it, in os-release, this file has line breaks, like os-release
			# but in case we  want it, it's: CODENAME = Mantis  | VERSION = 12.2 
			# for now, just take first occurrence, which should be the first line, which does not use a variable type format
			distro=$( grep -i -m 1 'suse' /etc/$distro_file )
		else
			distro=$( remove_erroneous_chars "/etc/$distro_file" )
		fi
	# otherwise try  the default debian/ubuntu /etc/issue file
	elif [[ -f /etc/issue ]];then
		# os-release/lsb gives more manageable and accurate output than issue, but mint should use issue for now
		# some bashism, boolean must be in parenthesis to work correctly, ie [[ $(boolean) ]] not [[ $boolean ]]
		if [[ $B_OS_RELEASE_FILE == 'true' ]] && [[ -z $( grep -i 'mint' /etc/issue ) ]];then
			distro=$( get_distro_lsb_os_release_data 'os-release-file' )
			b_osr='true'
		elif [[ $B_LSB_FILE == 'true' ]] && [[ -z $( grep -i 'mint' /etc/issue ) ]];then
			distro=$( get_distro_lsb_os_release_data 'lsb-file' )
		else
			distro=$( gawk '
			BEGIN {
				RS=""
			}
			{
				gsub(/\\[a-z]/, "")
				gsub(/'"$BAN_LIST_ARRAY"'/, " ")
				gsub(/^ +| +$/, "")
				gsub(/ [ \t]+/, " ")
				print
			}' /etc/issue )
			
			# this handles an arch bug where /etc/arch-release is empty and /etc/issue is corrupted
			# only older arch installs that have not been updated should have this fallback required, new ones use
			# os-release
			if [[ -n $( grep -i 'arch linux' <<< $distro ) ]];then
				distro='Arch Linux'
			fi
		fi
	fi
	# a final check. If a long value, before assigning the debugger output, if os-release
	# exists then let's use that if it wasn't tried already. Maybe that will be better.
	if [[ ${#distro} -gt 80 ]] && [[ $B_HANDLE_CORRUPT_DATA != 'true' ]];then
		if [[ $B_OS_RELEASE_FILE == 'true' && $b_osr == 'false' ]];then
			distro=$( get_distro_lsb_os_release_data 'os-release-file' )
		fi
		if [[ ${#distro} -gt 80 ]];then
			distro="${RED}/etc/$distro_file corrupted, use -% to override${NORMAL}"
		fi
	fi
	## note: would like to actually understand the method even if it's not used
	# : ${distro:=Unknown distro o_O}
	## test for /etc/lsb-release as a backup in case of failure, in cases where > one version/release file
	## were found but the above resulted in null distro value
	# Because os-release is now more common, we'll test for it first.
	if [[ -z $distro ]] && [[ $B_OS_RELEASE_FILE == 'true' ]];then
		distro=$( get_distro_lsb_os_release_data 'os-release-file' )
	fi
	if [[ -z $distro ]] && [[ $B_LSB_FILE == 'true' ]];then
		distro=$( get_distro_lsb_os_release_data 'lsb-file' )
	fi
	
	# now some final null tries
	if [[ -z $distro ]];then
		# if the file was null but present, which can happen in some cases, then use the file name itself to 
		# set the distro value. Why say unknown if we have a pretty good idea, after all?
		if [[ -n $distro_file ]] && [[ " $DISTROS_DERIVED $DISTROS_PRIMARY " == *" $distro_file "* ]];then
			distro=$( sed $SED_RX -e 's/[-_]//' -e 's/(release|version)//' <<< $distro_file | sed $SED_RX 's/^([a-z])/\u\1/' )
		fi
		## finally, if all else has failed, give up
		if [[ -z $distro ]];then
			distro='unknown'
		fi
	fi
	# final step cleanup of unwanted information
	# opensuse has the x86 etc type string in names, not needed as redundant since -S already shows that
	distro=$( gawk '
	BEGIN {
		IGNORECASE=1
	}
	{
		sub(/ *\(*(x86_64|i486|i586|i686|686|586|486)\)*/, "", $0)
		print $0
	}' <<< $distro )
	echo "$distro"
	log_function_data "distro: $distro"
	eval $LOGFE
}

# args: $1 - lsb-file/lsb-app/os-release-file
get_distro_lsb_os_release_data()
{
	eval $LOGFS
	local distro=''
	
	case $1 in
		lsb-file)
			if [[ $B_LSB_FILE == 'true' ]];then
				distro=$( gawk -F '=' '
				BEGIN {
					IGNORECASE=1
				}
				# clean out unwanted characters
				{ 
					gsub(/\\|\"|[:\47]/,"", $0 )
					gsub(/^[[:space:]]+|[[:space:]]+$/, "", $2 )
					gsub(/^[[:space:]]+|[[:space:]]+$/, "", $1 )
				}
				# note: adding the spacing directly to variable to make sure distro output is null if not found
				/^DISTRIB_ID/ {
					# this is needed because grep for "arch" is too loose to be safe
					if ( $2 == "arch" ) {
						distroId = "Arch Linux"
					}
					else if ( $2 != "n/a" ) {
						distroId = $2 " "
					}
				}
				/^DISTRIB_RELEASE/ {
					if ( $2 != "n/a" ) {
						distroRelease = $2 " "
					}
				}
				/^DISTRIB_CODENAME/ {
					if ( $2 != "n/a" ) {
						distroCodename = $2 " "
					}
				}
				# sometimes some distros cannot do their lsb-release files correctly, so here is
				# one last chance to get it right.
				/^DISTRIB_DESCRIPTION/ {
					if ( $2 != "n/a" ) {
						distroDescription = $2
					}
				}
				END {
					fullString=""
					if ( distroId == "" && distroRelease == "" && distroCodename == "" && distroDescription != "" ){
						fullString = distroDescription
					}
					else {
						fullString = distroId distroRelease distroCodename
					}
					print fullString
				}
				' $FILE_LSB_RELEASE )
				log_function_data 'cat' "$FILE_LSB_RELEASE"
			fi
			;;
		lsb-app)
			# this is HORRIBLY slow, not using
			if type -p lsb_release &>/dev/null;then
				distro=$( echo "$( lsb_release -irc )" | gawk -F ':' '
				BEGIN { 
					IGNORECASE=1 
				}
				# clean out unwanted characters
				{ 
					gsub(/\\|\"|[:\47]/,"", $0 )
					gsub(/^[[:space:]]+|[[:space:]]+$/, "", $2 )
					gsub(/^[[:space:]]+|[[:space:]]+$/, "", $1 )
				}
				/^Distributor ID/ {
					distroId = $2
				}
				/^Release/ {
					distroRelease = $2
				}
				/^Codename/ {
					distroCodename = $2
				}
				END {
					print distroId " " distroRelease " (" distroCodename ")"
				}' )
			fi
			;;
		os-release-file)
			if [[ $B_OS_RELEASE_FILE == 'true' ]];then
				distro=$( gawk -F '=' '
				BEGIN {
					IGNORECASE=1
					prettyName=""
					regularName=""
					versionName=""
					versionId=""
					distroName=""
				}
				# clean out unwanted characters
				{ 
					gsub(/\\|\"|[:\47]/,"", $0 )
					gsub(/^[[:space:]]+|[[:space:]]+$/, "", $2 )
					gsub(/^[[:space:]]+|[[:space:]]+$/, "", $1 )
				}
				# note: adding the spacing directly to variable to make sure distro output is null if not found
				/^PRETTY_NAME/ {
					if ( $2 != "n/a"  ) {
						prettyName = $2
					}
				}
				/^NAME/ {
					if ( $2 != "n/a" ) {
						regularName = $2
					}
				}
				/^VERSION/ {
					if ( $2 != "n/a" && $1 == "VERSION" ) {
						versionName = $2
					}
					else if ( $2 != "n/a" && $1 == "VERSION_ID" ) {
						versionId = $2
					}
				}
				END {
					# NOTE: tumbleweed has pretty name but pretty name does not have version id
					if ( prettyName != "" && regularName !~ /tumbleweed/ ) {
						distroName = prettyName
					}
					else if ( regularName != "" ) {
						distroName = regularName
						if ( versionName != "" ) {
							distroName = distroName " " versionName
						}
						else if ( versionId != "" ) {
							distroName = distroName " " versionId
						}
						
					}
					print distroName
				}
				' $FILE_OS_RELEASE )
				log_function_data 'cat' "$FILE_OS_RELEASE"
			fi
			;;
	esac
	echo $distro
	log_function_data "distro: $distro"
	eval $LOGFE
}
# Repos will be added as we get distro package manager data to create the repo data. 
# This method will output the file name also, which is useful to create output that's 
# neat and readable. Each line of the total number contains the following sections,
# separated by a : for splitting in the print function
# part one, repo type/string : part two, file name, if present, of info : part 3, repo data
# args: $1 - [file location of debug data file - optional, only for debugging data collection] 
get_repo_data()
{
	eval $LOGFS
	local repo_file='' repo_data_working='' repo_data_working2='' repo_line='' repo_files=''
	local repo_name=''
	local apt_file='/etc/apt/sources.list' yum_repo_dir='/etc/yum.repos.d/' yum_conf='/etc/yum.conf'
	local pacman_conf='/etc/pacman.conf' pacman_repo_dir='/etc/pacman.d/' pisi_dir='/etc/pisi/'
	local zypp_repo_dir='/etc/zypp/repos.d/' ports_conf='/etc/portsnap.conf' openbsd_conf='/etc/pkg.conf'
	local bsd_pkg_dir='/usr/local/etc/pkg/repos/' slackpkg_file='/etc/slackpkg/mirrors'
	local netbsd_file='/usr/pkg/etc/pkgin/repositories.conf' freebsd_file='/etc/freebsd-update.conf'
	local freebsd_pkg_file='/etc/pkg/FreeBSD.conf' slackpkg_plus_file='/etc/slackpkg/slackpkgplus.conf'
	local portage_repo_dir='/etc/portage/repos.conf/' apk_file='/etc/apk/repositories'
	
	# apt - debian, buntus, also sometimes some yum/rpm repos may create apt repos here as well
	if [[ -f $apt_file || -d $apt_file.d ]];then
		repo_files=$(ls /etc/apt/sources.list /etc/apt/sources.list.d/*.list 2>/dev/null)
		log_function_data "apt repo files: $repo_files"
		for repo_file in $repo_files
		do
			if [[ -n $1 ]];then
				cat $repo_file &> $1/repo-data_${repo_file//\//-}.txt
			fi
			repo_data_working="$( gawk -v repoFile="$repo_file" '
			!/^[[:space:]]*$|^[[:space:]]*#/ {
				print "apt sources^" repoFile "^" $0
			}' $repo_file )"
			get_repo_builder "$repo_data_working"
		done
		repo_data_working=''
	fi
	# yum - fedora, redhat, centos, etc. Note that rpmforge also may create apt sources
	# in /etc/apt/sources.list.d/. Therefore rather than trying to assume what package manager is
	# actually running, inxi will merely note the existence of each repo type for apt/yum. 
	# Also, in rpm, you can install apt-rpm for the apt-get command, so it's not good to check for
	# only the commands in terms of selecting which repos to show.
	if [[ -d $yum_repo_dir || -f $yum_conf || -d $zypp_repo_dir ]];then
		if [[ -d $yum_repo_dir || -f $yum_conf ]];then
			# older redhats put their yum data in /etc/yum.conf
			repo_files=$( ls $yum_repo_dir*.repo $yum_conf 2>/dev/null )
			repo_name='yum'
			log_function_data "yum repo files: $repo_files"
		elif [[ -d $zypp_repo_dir ]];then
			repo_files=$( ls $zypp_repo_dir*.repo 2>/dev/null )
			repo_name='zypp'
			log_function_data "zypp repo files: $repo_files"
		fi
		if [[ -n $repo_files ]];then
			for repo_file in $repo_files
			do
				if [[ -n $1 ]];then
					cat $repo_file &> $1/repo-data_${repo_file//\//-}.txt
				fi
				repo_data_working="$( gawk -v repoFile="$repo_file" '
				# construct the string for the print function to work with, file name: data
				function print_line( fileName, repoId, repoUrl ){
					print "'$repo_name' sources^" fileName "^" repoId  repoUrl
				}
				BEGIN {
					FS="\n"
					IGNORECASE=1
					enabledStatus=""
					repoTitle=""
					urlData=""
				}
				# this is a hack, assuming that each item has these fields listed, we collect the 3
				# items one by one, then when the url/enabled fields are set, we print it out and
				# reset the data. Not elegant but it works. Note that if enabled was not present
				# we assume it is enabled then, and print the line, reset the variables. This will
				# miss the last item, so it is printed if found in END
				/^\[.+\]/ {
					if ( urlData != "" && repoTitle != "" ){
						print_line( repoFile, repoTitle, urlData )
						enabledStatus=""
						urlData=""
						repoTitle=""
					}
					gsub(/\[|\]/, "", $1 ) # strip out the brackets
					repoTitle = $1 " ~ "
				}
				/^(mirrorlist|baseurl)/ {
					sub( /(mirrorlist|baseurl)[[:space:]]*=[[:space:]]*/, "", $1 ) # strip out the field starter
					urlData = $1
				}
				# note: enabled = 1. enabled = 0 means disabled
				/^enabled[[:space:]]*=/ {
					enabledStatus = $1
				}
				# print out the line if all 3 values are found, otherwise if a new
				# repoTitle is hit above, it will print out the line there instead
				{ 
					if ( urlData != "" && enabledStatus != "" && repoTitle != "" ){
						if ( enabledStatus !~ /enabled[[:space:]]*=[[:space:]]*0/ ){
							print_line( repoFile, repoTitle, urlData )
						}
						enabledStatus=""
						urlData=""
						repoTitle=""
					}
				}
				END {
					# print the last one if there is data for it
					if ( urlData != ""  && repoTitle != "" ){
						print_line( repoFile, repoTitle, urlData )
					}
				}
				' $repo_file )"
				# then load the global for each file as it gets filled
				get_repo_builder "$repo_data_working"
			done
		fi
		repo_data_working=''
	# pacman - archlinux, going to assume that pisi and arch/pacman, etc don't have the above issue with apt/yum
	elif [[ -f $pacman_conf ]];then
		# get list of mirror include files, trim white space off ends
		repo_data_working="$( gawk '
		BEGIN {
			FS="="
			IGNORECASE=1
		}
		/^[[:space:]]*Include/ {
			sub(/^[[:space:]]+|[[:space:]]+$/,"",$2)
			print $2
		}
		' $pacman_conf )"
		# sort into unique paths only, to be used to search for server = data
		repo_data_working=$( sort -bu <<< "$repo_data_working" | uniq ) 
		repo_data_working="$repo_data_working $pacman_conf"
		for repo_file in $repo_data_working 
		do
			if [[ -n $1 ]];then
				cat $repo_file &> $1/repo-data_${repo_file//\//-}.txt
			fi
			if [[ -f $repo_file ]];then
				# inserting a new line after each found / processed match
				repo_data_working2="$repo_data_working2$( gawk -v repoFile=$repo_file '
				BEGIN {
					FS="="
					IGNORECASE=1
				}
				/^[[:space:]]*Server/ {
					sub(/^[[:space:]]+|[[:space:]]+$/,"",$2)
					print "pacman repo servers^" repoFile "^" $2 "\\n"
				}
				' $repo_file )"
			else
				echo "Error: file listed in $pacman_conf does not exist - $repo_file"
			fi
		done
		# execute line breaks
		REPO_DATA="$( echo -e $repo_data_working2 )"
		repo_data_working=''
	# pisi - pardus
	elif [[ -f $slackpkg_file || -f $slackpkg_plus_file ]];then
		# note, only one file, but loop it in case more are added in future
		if [[ -f $slackpkg_file ]];then
			if [[ -n $1 ]];then
				cat $slackpkg_file &> $1/repo-data_${slackpkg_file//\//-}.txt
			fi
			repo_data_working="$( gawk -v repoFile="$slackpkg_file" '
			!/^[[:space:]]*$|^[[:space:]]*#/ {
				print "slackpkg sources^" repoFile "^" $0
			}' $slackpkg_file )"
			get_repo_builder "$repo_data_working"
		fi
		if [[ -f $slackpkg_plus_file ]];then
			if [[ -n $1 ]];then
				cat $slackpkg_plus_file &> $1/repo-data_${slackpkg_plus_file//\//-}.txt
			fi
			# see sample for syntax
			repo_data_working="$( gawk -F '=' -v repoFile="$slackpkg_plus_file" '
			BEGIN {
				activeRepos=""
			}
			# stop if set to off
			/^SLACKPKGPLUS/ {
				if ( $2 == "off" ){
					exit
				}
			}
			# get list of current active repos
			/^REPOPLUS/ {
				activeRepos=$2
			}
			# print out repo line if found
			/^MIRRORPLUS/ {
				if ( activeRepos != "" ) {
					gsub(/MIRRORPLUS\['\''|'\''\]/,"",$1)
					if ( match( activeRepos, $1 ) ){
						print "slackpkg+ sources^" repoFile "^" $1 " ~ " $2
					}
				}
			}' $slackpkg_plus_file )"
			get_repo_builder "$repo_data_working"
		fi
		repo_data_working=''
	elif [[ -d $portage_repo_dir && -n $( type -p emerge ) ]];then
		repo_files=$( ls $portage_repo_dir*.conf 2>/dev/null )
		repo_name='portage'
		log_function_data "portage repo files: $repo_files"
		if [[ -n $repo_files ]];then
			for repo_file in $repo_files
			do
				if [[ -n $1 ]];then
					cat $repo_file &> $1/repo-data_${repo_file//\//-}.txt
				fi
				repo_data_working="$( gawk -v repoFile="$repo_file" '
				# construct the string for the print function to work with, file name: data
				function print_line( fileName, repoId, repoUrl ){
					print "'$repo_name' sources^" fileName "^" repoId  repoUrl
				}
				BEGIN {
					FS="\n"
					IGNORECASE=1
					enabledStatus=""
					repoTitle=""
					urlData=""
				}
				# this is a hack, assuming that each item has these fields listed, we collect the 3
				# items one by one, then when the url/enabled fields are set, we print it out and
				# reset the data. Not elegant but it works. Note that if enabled was not present
				# we assume it is enabled then, and print the line, reset the variables. This will
				# miss the last item, so it is printed if found in END
				/^\[.+\]/ {
					if ( urlData != "" && repoTitle != "" ){
						print_line( repoFile, repoTitle, urlData )
						enabledStatus=""
						urlData=""
						repoTitle=""
					}
					gsub(/\[|\]/, "", $1 ) # strip out the brackets
					repoTitle = $1 " ~ "
				}
				/^(sync-uri)/ {
					sub( /sync-uri[[:space:]]*=[[:space:]]*/, "", $1 ) # strip out the field starter
					urlData = $1
				}
				# note: enabled = 1. enabled = 0 means disabled
				/^auto-sync[[:space:]]*=/ {
					sub( /auto-sync[[:space:]]*=[[:space:]]*/, "", $1 ) # strip out the field starter
					enabledStatus = $1
				}
				# print out the line if all 3 values are found, otherwise if a new
				# repoTitle is hit above, it will print out the line there instead
				{ 
					if ( urlData != "" && enabledStatus != "" && repoTitle != "" ){
						if ( enabledStatus !~ /enabled[[:space:]]*=[[:space:]]*0/ ){
							print_line( repoFile, repoTitle, urlData )
						}
						enabledStatus=""
						urlData=""
						repoTitle=""
					}
				}
				END {
					# print the last one if there is data for it
					if ( urlData != ""  && repoTitle != "" ){
						print_line( repoFile, repoTitle, urlData )
					}
				}
				' $repo_file )"
				# then load the global for each file as it gets filled
				get_repo_builder "$repo_data_working"
			done
		fi
	elif [[ -d $pisi_dir && -n $( type -p pisi ) ]];then
		REPO_DATA="$( pisi list-repo )"
		if [[ -n $1 ]];then
			echo "$REPO_DATA" &> $1/repo-data_pisi-list-repo.txt
		fi
		log_function_data "pisi-list-repo: $REPO_DATA"
		# now we need to create the structure: repo info: repo path
		# we do that by looping through the lines of the output and then
		# putting it back into the <data>:<url> format print repos expects to see
		# note this structure in the data, so store first line and make start of line
		# then when it's an http line, add it, and create the full line collection.
# Pardus-2009.1 [Aktiv]
# 	http://packages.pardus.org.tr/pardus-2009.1/pisi-index.xml.bz2
# Contrib [Aktiv]
# 	http://packages.pardus.org.tr/contrib-2009/pisi-index.xml.bz2
		while read repo_line
		do
			repo_line=$( gawk '
			{
				# need to dump leading/trailing spaces and clear out color codes for irc output
				sub(/^[[:space:]]+|[[:space:]]+$/,"",$0)
# 				gsub(/\x1B\[([0-9]{1,2}(;[0-9]{1,2})?)?[m|K]/,"",$0) # leaving this pattern in case need it
				gsub(/\[([0-9];)?[0-9]+m/,"",$0)
				print $0
			}' <<< $repo_line )
			if [[ -n $( grep '://' <<< $repo_line ) ]];then
				repo_data_working="$repo_data_working^$repo_line\n"
			else
				repo_data_working="${repo_data_working}pisi repo^$repo_line"
			fi
		done <<< "$REPO_DATA"
		# echo and execute the line breaks inserted
		REPO_DATA="$( echo -e $repo_data_working )"
		repo_data_working=''
	# Mandriva/Mageia using: urpmq
	elif type -p urpmq &>/dev/null;then
		REPO_DATA="$( urpmq --list-media active --list-url )"
		if [[ -n $1 ]];then
			echo "$REPO_DATA" &> $1/repo-data_urpmq-list-media-active.txt
		fi
		# now we need to create the structure: repo info: repo path
		# we do that by looping through the lines of the output and then
		# putting it back into the <data>:<url> format print repos expects to see
		# note this structure in the data, so store first line and make start of line
		# then when it's an http line, add it, and create the full line collection.
# Contrib ftp://ftp.uwsg.indiana.edu/linux/mandrake/official/2011/x86_64/media/contrib/release
# Contrib Updates ftp://ftp.uwsg.indiana.edu/linux/mandrake/official/2011/x86_64/media/contrib/updates
# Non-free ftp://ftp.uwsg.indiana.edu/linux/mandrake/official/2011/x86_64/media/non-free/release
# Non-free Updates ftp://ftp.uwsg.indiana.edu/linux/mandrake/official/2011/x86_64/media/non-free/updates
# Nonfree Updates (Local19) /mnt/data/mirrors/mageia/distrib/cauldron/x86_64/media/nonfree/updates
		while read repo_line
		do
			repo_line=$( gawk '
			{
				# need to dump leading/trailing spaces and clear out color codes for irc output
				sub(/^[[:space:]]+|[[:space:]]+$/,"",$0)
# 				gsub(/\x1B\[([0-9]{1,2}(;[0-9]{1,2})?)?[m|K]/,"",$0) # leaving this pattern in case need it
				gsub(/\[([0-9];)?[0-9]+m/,"",$0)
				print $0
			}' <<< $repo_line )
			# urpmq output is the same each line, repo name space repo url, can be:
			# rsync://, ftp://, file://, http:// OR repo is locally mounted on FS in some cases
			if [[ -n $( grep -E '(://|[[:space:]]/)' <<< $repo_line ) ]];then
				# cut out the repo first
				repo_data_working2=$( grep -Eo '([^[:space:]]+://|[[:space:]]/).*' <<< $repo_line )
				# then get the repo name string by slicing out the url string
				repo_name=$( sed "s|[[:space:]]*$repo_data_working2||" <<< $repo_line )
				repo_data_working="${repo_data_working}urpmq repo^$repo_name^$repo_data_working2\n"
			fi
		done <<< "$REPO_DATA"
		# echo and execute the line breaks inserted
		REPO_DATA="$( echo -e $repo_data_working )"
	# alpine linux
	elif [[ -f $apk_file ]];then
		# note, only one file, but loop it in case more are added in future
		for repo_file in $apk_file
		do
			if [[ -n $1 ]];then
				cat $repo_file &> $1/repo-data_${repo_file//\//-}.txt
			fi
			repo_data_working="$( gawk -v repoFile="$repo_file" '
			!/^[[:space:]]*$|^[[:space:]]*#/ {
				print "APK repo^" repoFile "^" $0
			}' $repo_file )"
			get_repo_builder "$repo_data_working"
		done
		repo_data_working=''
	elif [[ -f $ports_conf || -f $freebsd_file || -d $bsd_pkg_dir ]];then
		if [[ -f $ports_conf ]];then
			if [[ -n $1 ]];then
				cat $ports_conf &> $1/repo-data_${ports_conf//\//-}.txt
			fi
			repo_data_working="$( gawk -F '=' -v repoFile=$ports_conf '
			BEGIN {
				IGNORECASE=1
			}
			/^SERVERNAME/ {
				print "BSD ports server^" repoFile "^" $2
				exit
			}
			' $ports_conf )"
			get_repo_builder "$repo_data_working"
		fi
		if [[ -f $freebsd_file ]];then
			if [[ -n $1 ]];then
				cat $freebsd_file &> $1/repo-data_${freebsd_file//\//-}.txt
			fi
			repo_data_working="$( gawk -v repoFile=$freebsd_file '
			BEGIN {
				IGNORECASE=1
			}
			/^ServerName/ {
				print "FreeBSD update server^" repoFile "^" $2
				exit
			}
			' $freebsd_file )"
			get_repo_builder "$repo_data_working"
		fi
		if [[ -f $freebsd_pkg_file ]];then
			if [[ -n $1 ]];then
				cat $freebsd_pkg_file &> $1/repo-data_${freebsd_pkg_file//\//-}.txt
			fi
			repo_data_working="$( gawk -F ': ' -v repoFile=$freebsd_pkg_file '
			BEGIN {
				IGNORECASE=1
			}
			$1 ~ /^[[:space:]]*url/ {
				gsub(/\"|pkg\+|,/,"",$2)
				print "FreeBSD default pkg server^" repoFile "^" $2
				exit
			}
			' $freebsd_pkg_file )"
			get_repo_builder "$repo_data_working"
		fi
		
		if [[ -d $bsd_pkg_dir ]];then
			repo_files=$(ls ${bsd_pkg_dir}*.conf 2>/dev/null )
			for repo_file in $repo_files
			do
				if [[ -n $1 ]];then
					cat $repo_file &> $1/repo-data_${repo_file//\//-}.txt
				fi
				repo_data_working="$( gawk -v repoFile=$repo_file '
				BEGIN {
					FS=":"
					IGNORECASE=1
					repoName=""
					repoUrl=""
					enabled=""
				}
				{
					gsub(/{|}|^#.*/,"",$0)
				}
				/^[^[:space:]]/ {
					repoName=$1
					repoUrl=""
					enabled=""
					while ( getline && $0 !~ /^[[:space:]]*$/ ) {
						gsub(/'"$BAN_LIST_ARRAY"'/,"",$0)
						gsub(/({|}|^[[:space:]]+|[[:space:]]+$)/,"",$1)
						gsub(/({|}|^[[:space:]]+|[[:space:]]+$)/,"",$2)
						if ( $1 == "url" ) {
							repoUrl=$2$3
						}
						if ( $1 == "enabled" ) {
							if ( $2 == "yes" ) {
								print "BSD pkg server^" repoFile "^" repoName " ~ " repoUrl 
							}
						}
					}
				}
				' $repo_file )"
				get_repo_builder "$repo_data_working"
			done
		fi
		repo_data_working=''
	elif [[ -f $openbsd_conf ]];then
		if [[ -n $1 ]];then
			cat $openbsd_conf &> $1/repo-data_${openbsd_conf//\//-}.txt
		fi
		REPO_DATA="$( gawk -F '=' -v repoFile=$openbsd_conf '
		BEGIN {
			IGNORECASE=1
		}
		/^installpath/ {
			print "OpenBSD pkg mirror^" repoFile "^" $2
		}
		' $openbsd_conf )"
	elif [[ -f $netbsd_file ]];then
		# note, only one file, but loop it in case more are added in future
		for repo_file in $netbsd_file
		do
			if [[ -n $1 ]];then
				cat $repo_file &> $1/repo-data_${repo_file//\//-}.txt
			fi
			repo_data_working="$( gawk -v repoFile="$repo_file" '
			!/^[[:space:]]*$|^[[:space:]]*#/ {
				print "NetBSD pkg servers^" repoFile "^" $0
			}' $repo_file )"
			get_repo_builder "$repo_data_working"
		done
		repo_data_working=''
	fi
	eval $LOGFE
}
# build the total REPO_DATA global here
# args: $1 - the repo line/s

# currently only apt using distros support this feature, but over time we can add others
print_repo_data()
{
	eval $LOGFS
	local repo_count=0 repo_line='' file_name='' file_content='' file_name_holder=''
	local repo_full='' b_print_next_line='false' repo_type=''
	
	get_repo_data
	
	if [[ -n $REPO_DATA ]];then
		# loop through the variable's lines one by one, update counter each iteration
		while read repo_line
		do
			(( repo_count++ ))
			repo_type=$( cut -d '^' -f 1 <<< $repo_line )
			file_name=$( cut -d '^' -f 2 <<< $repo_line )
			file_content=$( cut -d '^' -f 3-7 <<< $repo_line )
			# this will dump unwanted white space line starters. Some irc channels
			# use bots that show page title for urls, so need to break the url by adding 
			# a white space.
			if [[ $B_IRC == 'true' ]];then
				file_content=$( echo ${file_content/:\/\//: \/\/} )
			else
				file_content=$( echo $file_content )
			fi
			# echo $file_name : $file_name_holder : $repo_type : $file_content
			# check file name, if different, update the holder for print out
			if [[ $file_name != $file_name_holder ]];then
				if [[ $repo_type == 'pisi repo' || $repo_type == 'urpmq repo' ]];then
					repo_full="${C1}$repo_type$SEP3${C2} $file_name"
				else
					repo_full="${C1}Active $repo_type in file$SEP3${C2} $file_name"
				fi
				file_name_holder=$file_name
				b_print_next_line='true'
			else
				repo_full="${C2}$file_content"
			fi
			# first line print Repos: 
			if [[ $repo_count -eq 1 ]];then
				repo_full=$( create_print_line "Repos:" "$repo_full" )
			else
				repo_full=$( create_print_line " " "$repo_full" )
			fi
			print_screen_output "$repo_full"
			# this prints the content of the file as well as the file name
			if [[ $b_print_next_line == 'true' ]];then
				repo_full=$( create_print_line " " "$file_content" )
				print_screen_output "$repo_full"
				b_print_next_line='false'
			fi
		done <<< "$REPO_DATA"
	else
		if [[ $BSD_TYPE == 'bsd' ]];then
			repo_type='OS type'
		else
			repo_type="package manager"
		fi
		repo_full=$( create_print_line "Repos:" "${C1}Error$SEP3${C2} No repo data detected. Does $SELF_NAME support your $repo_type?" )
		print_screen_output "$repo_full"
	fi
	eval $LOGFE
}

#	local distro="$( get_distro_data )"
#	local tty_session='' compiler_string='' distro_os='Distro'
